Merge branch 'master' of ssh://git@git.grml.org/grml-debootstrap
[grml-debootstrap.git] / grml-debootstrap
index 5e15790..984aa1a 100755 (executable)
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Mon Apr 16 19:35:55 CEST 2007 [mika]
 ################################################################################
 # http://www.debian.org/releases/stable/i386/index.html.en
 
 set -e # exit on any error
 
-VERSION='0.7'
+# variables {{{
+PN="$(basename $0)"
+VERSION='0.23'
+MNTPOINT="/mnt/debootstrap.$$"
+
+# inside the chroot system locales might not be available, so use minimum:
+export LANG=C
+export LC_ALL=C
+
+# make sure interactive mode is only executed when
+# using an empty configuration file or option --interactive
+INTERACTIVE=''
+# }}}
 
 # source core functions {{{
 . /etc/grml/lsb-functions
 . /etc/grml/script-functions
 # }}}
 
+# help text {{{
+usage() {
+  echo "$PN - wrapper around debootstrap for installing Debian
+
+Usage: $PN [options]
+
+Bootstrap options:
+
+  -m, --mirror=URL       Mirror which should be used for apt-get/aptitude.
+  -i, --iso=mnt          Mountpoint where a Debian ISO is mounted to, for use
+                           instead of fetching packages from a mirror.
+  -r, --release=name     Release of new Debian system (default: stable).
+  -t, --target=target    Target partition (/dev/...) or directory.
+  -p, --mntpoint=mnt     Mountpoint used for mounting the target system.
+      --debopt=params    Extra parameters passed to the debootstrap.
+      --interactive      Use interactive mode (frontend).
+      --nodebootstrap    Skip debootstrap, only do configuration to the target.
+
+Configuration options:
+
+
+  -c, --config=file      Use specified configuration file, defaults to
+                           /etc/debootstrap/config
+  -d, --confdir=path     Place of config files for debootstrap, defaults to
+                           /etc/debootstrap
+      --packages[=f]     Install packages defined in <confdir>/packages. Option
+                           arg: alternative package list file.
+      --debconf[=f]      Pre-seed packages using <confdir>/debconf-selections.
+                           Option arg: alternative pre-seed db file.
+      --keep_src_list    Do not overwrite user provided apt sources.list.
+      --hostname=name    Hostname of Debian system.
+      --password=pwd     Use specified password as password for user root.
+
+      --bootappend=line  Add specified appendline to kernel whilst booting.
+      --groot=device     Root device for usage in grub, corresponds with
+                           $TARGET in grub syntax, like hd0,0 for /dev/sda1.
+      --grub=device      Target for grub installation. Use grub syntax for
+                           specifying, like hd0 for /dev/sda.
+
+Other options:
+
+  -v, --verbose          Increase verbosity.
+  -h, --help             Print this usage information and exit.
+  -V, --version          Show summary of options and exit.
+
+Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
+"
+}
+
+if [ "$1" = '-h' ] || [ "$1" = '-help' ] ; then
+   usage
+   echo 'Please notice that this script requires root permissions!'
+   exit 0
+fi
+# }}}
+
 # make sure we have what we need {{{
-check4progs debootstrap || exit 1
+check4progs debootstrap dialog || exit 1
 check4root || exit 1
 # }}}
 
-# without config file it won't work {{{
+# source configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
-   . /etc/debootstrap/config
-else
-   eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
-   exit 1
+   if [ -n "$CONFIGFILE" ] ; then
+      einfo "Using config file $CONFIGFILE."
+      if ! . "$CONFIGFILE" ; then
+         eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
+      fi
+   else
+      . /etc/debootstrap/config
+   fi
 fi
 # }}}
 
 # cmdline handling {{{
-usage() {
-  einfo "$0 - version $VERSION"
-  echo  "   A wrapper around debootstrap for installing plain Debian via grml"
-  echo
-  einfo "Usage: $0 [options]"
-  echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
-  echo
-  einfo "Valid options:"
-  echo  "
-    -h|--help              Print this usage information and exit.
-    -v|--version           Show summary of options and exit.
-
-    -t|--target <target>   Target partition (/dev/...) or directory.
-    -r|--release <release> Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
-    -m|--mirror <URL>      Specify mirror which should be used for apt-get/aptitude.
-    -p|--mntpoint <mnt>    Specify mountpoint that should be used for mounting the target system.
-    --groot <device>       Specify root device for usage in grub (corresponds with \$TARGET).
-    --grub <device>        Where do you want to install grub to? Use grub syntax for specifying.
-    --password <pwd>       Use specified password as password for user root. Use with caution.
+# source external command line parameter-processing script
+. /usr/share/grml-debootstrap/functions/cmdlineopts.clp
 
-"
+# == business-logic of command line parameter-processing
+
+# source configuration file in <confdir> if supplied. {{{
+[ "$_opt_confdir" ] && {
+  CONFFILES=$_opt_confdir
+  einfo "Using config files under $CONFFILES/."
+  if ! [ -r "$CONFFILES/config" ] ; then
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+  fi
+  if ! . "$CONFFILES/config" ; then
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+  fi
+  # restore the command line parameter value
+  CONFFILES=$_opt_confdir
+}
+# }}}
+
+[ "$_opt_mirror" ]             && MIRROR=$_opt_mirror
+[ "$_opt_iso" ]                        && ISO=$_opt_iso
+[ "$_opt_release" ]            && RELEASE=$_opt_release
+[ "$_opt_target" ]             && TARGET=$_opt_target
+[ "$_opt_mntpoint" ]           && MNTPOINT=$_opt_mntpoint
+[ "$_opt_debopt" ]             && DEBOOTSTRAP_OPT=$_opt_debopt
+[ "$_opt_interactive" ]                && INTERACTIVE=1
+[ "$_opt_config" ]             && CONFIGFILE=$_opt_config
+[ "$_opt_packages_set" ]       && PACKAGES='yes'
+[ "$_opt_debconf_set" ]                && DEBCONF='yes'
+[ "$_opt_keep_src_list" ]      && KEEP_SRC_LIST='yes'
+[ "$_opt_hostname" ]           && HOSTNAME=$_opt_hostname
+[ "$_opt_password" ]           && ROOTPASSWORD=$_opt_password
+[ "$_opt_bootappend" ]         && BOOT_APPEND=$_opt_bootappend
+[ "$_opt_groot" ]              && GROOT=$_opt_groot
+[ "$_opt_grub" ]               && GRUB=$_opt_grub
+[ "$_opt_verbose" ]            && VERBOSE="-v"
+
+[ "$_opt_help" ] && {
+  usage ; eend 0
+  eend 0
+  exit 0
+}
+
+[ "$_opt_version" ] && {
+  einfo "$PN - version $VERSION"
+  einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
+  eend 0
+  exit 0
+}
+# }}}
+
+# welcome screen {{{
+welcome_dialog()
+{
+   dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
+Do you want to continue installing Debian using this frontend?" 0 0
+}
+# }}}
+
+# ask for target {{{
+prompt_for_target()
+{
+  AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
+               sed 's/*//' | \
+               grep -v 'Extended$' | \
+               gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+
+  if [ -z "$AVAILABLE_PARTITIONS" ] ; then
+     dialog --title "$PN" --trim \
+     --msgbox "Sorry, no partitions found. Please configure your
+     harddisks (see /proc/partitions) using a tool like fdisk,
+     cfdisk, gpart, gparted,..." 0 0
+     exit 0
+  fi
+
+  PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
+                       echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
+                   done)
+
+  TARGET=$(dialog --title "$PN" --single-quoted --stdout \
+         --menu "Please select the target partition:" 0 0 0 \
+         $PARTITION_LIST)
+}
+# }}}
+
+# ask for bootmanager {{{
+prompt_for_bootmanager()
+{
+  ADDITIONAL_PARAMS=""
+  for device in sda hda; do
+    if [ /dev/$device != ${TARGET%[0-9]} ]; then
+      grep -q $device /proc/partitions && \
+      ADDITIONAL_PARAMS=:$device:"install bootmanager grub into MBR of /dev/${device}"
+    fi
+  done
+  ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
+
+  OIFS="$IFS"; IFS=:
+
+  if echo $TARGET | grep -q "/dev/md" ; then
+     MBRPART="all disks of Software RAID $TARGET"
+  else
+     MBRPART="MBR of ${TARGET%[0-9]}"
+  fi
+
+  GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
+          --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
+            mbr       "install bootmanager into $MBRPART" \
+            partition "install bootmanager into partition $TARGET" \
+            nowhere   "do not install bootmanager at all" \
+          ${ADDITIONAL_PARAMS})
+  [ $? -eq 0 ] || bailout 3
+  IFS="$OIFS"
+
+  case "$GETMBR" in
+    mbr)
+      # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
+      if echo $TARGET | grep -q "*md*" ; then
+         BOOT_PARTITION="${TARGET}"
+      else
+         BOOT_PARTITION="${TARGET%[0-9]}"
+      fi
+      ;;
+    partition)
+      BOOT_PARTITION="$TARGET"
+      ;;
+    hda)
+      BOOT_PARTITION="/dev/hda"
+      ;;
+    sda)
+      BOOT_PARTITION="/dev/sda"
+      ;;
+    nowhere)
+      BOOT_PARTITION=''
+      ;;
+  esac
+}
+# }}}
+
+# ask for Debian release {{{
+prompt_for_release()
+{
+  RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
+            "Please enter the Debian release you would like to use for installation:" \
+            0 50 3 \
+            etch   Debian/stable \
+            lenny  Debian/testing \
+            sid    Debian/unstable)"
+}
+# }}}
+
+# ask for hostname {{{
+prompt_for_hostname()
+{
+  HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
+            "Please enter the hostname you would like to use for installation:" \
+            0 0 grml)"
+}
+# }}}
+
+# ask for password {{{
+prompt_for_password()
+{
+     ROOTPW1='PW1'
+     ROOTPW2='PW2'
+     while [ "$ROOTPW1" != "$ROOTPW2" ]; do
+       ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account:" 10 60)
+       ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
+       "Please enter the password for the root account again for \
+       confirmation:" 10 60)
+
+       if [ "$ROOTPW1" != "$ROOTPW2" ]; then
+         $(dialog --stdout --title "${PN}" --ok-label \
+         "Retry" --msgbox "Passwords do not match!" 10 60)
+       fi
+     done
+     ROOTPASSWORD="$ROOTPW1"
+}
+# }}}
+
+# ask for Debian mirror {{{
+prompt_for_mirror()
+{
+  MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
+            "Please enter Debian mirror you would like to use for installing packages." \
+            0 0 http://ftp.de.debian.org/debian)"
+}
+# }}}
+
+# get grub's syntax for /dev/ice {{{
+# usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
+grubdevice() {
+  if [ -z "$1" ] ; then
+     echo "Usage: grubdevice <device>">&2
+     return 1
+  fi
+
+  device="$1"
+  device_map=/boot/grub/device.map
+
+  # create device.map
+  if ! [ -f "$device_map" ] ; then
+     echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
+  fi
+
+  # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
+  tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
+                    -e 's%\(fd[0-9]*\)$%\1%' \
+                    -e 's%/part[0-9]*$%/disc%' \
+                    -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
+  tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
+                    -e 's%.*/fd[0-9]*$%%' \
+                    -e 's%.*/floppy/[0-9]*$%%' \
+                    -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
+                    -e 's%.*c[0-7]d[0-9]*p*%%'`
+  tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
+
+  case $1 in
+     /dev/[sh]d[a-z]) # we expect something like 'hd0'
+        echo "$tmp_drive"
+        ;;
+      *) # we expect something like 'hd0,0'
+        echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
+        ;;
+  esac
 }
+# }}}
 
-while [ "$#" -gt "0" ] ; do
-    case $1 in
-        -v|--version)
-            einfo "$0 - version $VERSION"
-            einfo "Send bug reports to Michael Prokop <mika@grml.org>."
-            eend 0
-            exit 0
-            ;;
-        -t|--target)
-            shift
-            TARGET=$1
-            ;;
-        --grub)
-            shift
-            GRUB=$1
-            ;;
-        --groot)
-            shift
-            GROOT=$1
-            ;;
-        --release)
-            shift
-            RELEASE=$1
-            ;;
-        -p|--mntpoint)
-            shift
-            MNTPOINT=$1
-            ;;
-        --password)
-            shift
-            ROOTPASSWORD=$1
-            ;;
-        -m|--mirror)
-            shift
-            MIRROR=$1
-            CHROOTMIRROR=$1
-            ;;
-        -h|--help)
-            usage ; eend 0
-            eend 0
-            exit 0
-            ;;
-        *)
-            eerror "Syntax error."
-            usage ; eend 1
-            exit 1
-            ;;
-    esac
-    shift
+# software raid setup {{{
+config_swraid_setup()
+{
+TMPFILE=$(mktemp)
+
+# Currently we support only raid1:
+RAIDLEVEL='raid1'
+
+#RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
+#                   --menu "Which RAID level do you want to use?" 0 0 0 \
+#                     raid1 "Software RAID level 1" \
+#                     raid5 "Software RAID level 5")
+#[ $? -eq 0 ] || bailout 20
+
+MD_LIST=$(for i in $(seq 0 9) ; do
+            awk '{print $4}' /proc/partitions | grep -q md$i || \
+            echo "/dev/md$i /dev/md$i"
+          done)
+
+TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
+--menu "Which device do you want to use for ${RAIDLEVEL}?
+
+Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
+$MD_LIST)
+[ $? -eq 0 ] || bailout 20
+
+AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
+             sed 's/*//' | \
+             grep -v 'Extended$' | \
+             gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
+[ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
+PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
+                     echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
+                 done)
+
+dialog --title "$PN" --separate-output \
+       --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
+       $PARTITION_LIST 2>$TMPFILE
+RETVAL=$?
+SELECTED_PARTITIONS="$(cat $TMPFILE)"
+
+NUM_PARTITIONS=0
+for i in $(cat $TMPFILE) ; do
+   NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
 done
+
+ERRORFILE=$(mktemp)
+set +e
+# TODO: better error handling?
+yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
+      --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} 1>/dev/null 2>$ERRORFILE
+RC=$?
+set -e
+
+if [ "$RC" = 0 ] ; then
+   dialog --title "$PN" --msgbox \
+   "Creating $TARGET was successful." 0 0
+   rm -f "$TMPFILE" "$ERRORFILE"
+else
+   dialog --title "$PN" --msgbox \
+   "There was an error setting up $TARGET:
+
+$(cat $ERRORFILE)
+
+Exiting." 0 0
+   rm -f "$TMPFILE" "$ERRORFILE"
+   exit 1
+fi
+
+}
+
+prompt_for_swraid()
+{
+if dialog --stdout --title "$PN" \
+          --defaultno --yesno "Do you want to configure Software RAID?
+
+Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
+  config_swraid_setup
+fi
+}
 # }}}
 
-# set/check variables {{{
+# make sure the user is aware of the used configuration {{{
+checkconfiguration()
+{
+if [ -n "$AUTOINSTALL" ] ; then
+   if checkforrun ; then
+      eerror "Exiting as requested" ; eend 0
+      exit 1
+   fi
+elif [ -n "$INTERACTIVE" ] ; then
 
-# inside the chroot system the locales might not be available, so use minimum:
-export LANG=C
-export LC_ALL=C
+   INFOTEXT="Please recheck configuration before execution:
+   "
+   [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
+   Target:          $TARGET"
+   [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
+   Install grub:    $GRUB"
+   [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
+   Using release:   $RELEASE"
+   [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
+   Using hostname   $HOSTNAME"
+   [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
+   Using mirror:    $MIRROR"
+
+   INFOTEXT="$INFOTEXT
+
+Is this ok for you? Notice: selecting 'No' will exit ${PN}."
+
+   dialog --title "$PN" --no-collapse \
+          --yesno "$INFOTEXT" 0 0
+
+else # if not running automatic installation display configuration and prompt for execution:
+   einfo "$PN - Please recheck configuration before execution:"
+   echo
+   echo "   Target:          $TARGET"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
+      [ -n "$GRUB" ]    && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
+      [ -n "$RELEASE" ] && echo "   Using release:   $RELEASE"
+      [ -n "$MIRROR" ]  && echo "   Using mirror:    $MIRROR"
+      [ -n "$ISO" ]     && echo "   Using iso:       $ISO"
+      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
+      echo
+   einfon "Is this ok for you? [y/N] "
+   read a
+   if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
+      eerror "Exiting as requested." ; eend 1
+      exit 1
+   fi
+fi
+}
+# }}}
+
+# interactive mode {{{
+interactive_mode()
+{
+  welcome_dialog
+
+  prompt_for_swraid
+
+  # do not prompt for partition dialog if swraid has been configured already
+  [ -n "$TARGET" ] || prompt_for_target
+
+  prompt_for_bootmanager
 
+  prompt_for_release
+
+  prompt_for_hostname
+
+  prompt_for_password
+
+  # use first disk of sw-raid for grub by default, install grub on
+  # all involved disks later on
+  if echo "$TARGET" | grep -q '/dev/md' ; then
+     if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+        # use hdX and not hdX,Y for $GRUB
+        TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
+        GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
+        GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
+        echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
+     fi
+  else
+     [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
+     [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
+  fi
+
+  prompt_for_mirror
+
+  checkconfiguration
+}
+
+# run interactive mode if we didn't get the according configuration yet
+if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
+   # only target might be unset, so make sure the INTERACTIVE flag is set as well
+   INTERACTIVE=1
+   interactive_mode
+fi
+# }}}
+
+# finally make sure at least $TARGET is set [the partition for the new system] {{{
+if [ -n "$TARGET" ] ; then
+   SHORT_TARGET="${TARGET##*/}"
+else
+   eerror "Please adjust $CONFFILES/config or..."
+   eerror "... use the interactive version for configuration before running ${0}" ; eend 1
+   exit 1
+fi
+# }}}
+
+# stages setup {{{
 if [ -z "$STAGES" ] ; then
-   STAGES='/etc/debootstrap/stages'
+   STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
    [ -d "$STAGES" ] || mkdir -p "$STAGES"
 fi
 
-if [ -r $STAGES/grml-debootstrap ] ; then
+if [ -r "$STAGES"/grml-debootstrap ] ; then
    if grep -q done $STAGES/grml-debootstrap ; then
       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
    fi
 fi
+# }}}
 
+# partition handling {{{
 PARTITION=''
 DIRECTORY=''
 
@@ -143,7 +555,9 @@ case $TARGET in
     GROOT=''
     ;;
 esac
+# }}}
 
+# architecture setup {{{
 if [ -n "$ARCH" ] ; then
    ARCHCMD="--arch $ARCH"
    ARCHINFO=" (${ARCH})"
@@ -152,23 +566,20 @@ else
    ARCHCMD="--arch $ARCH"
    ARCHINFO=" (${ARCH})"
 fi
+# }}}
 
-# provide variables to chroot system
-touch /etc/debootstrap/variables
-chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
-[ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
-[ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
-[ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
-[ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
-[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
-[ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
-[ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
-
-# make sure at least $TARGET is set [the partition for the new system]
-if [ -z "$TARGET" ] ; then
-   eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
-   exit 1
+# make sure we have the right syntax when using an iso image {{{
+if [ -n "$ISO" ] ; then
+   case $ISO in
+      file*) # do nothing
+      ;;
+      *)
+      ISO=file:$1
+      ;;
+   esac
 fi
+ISODIR=${ISO##file:}
+ISODIR=${ISODIR%%/}
 # }}}
 
 # helper functions {{{
@@ -185,22 +596,38 @@ bailout(){
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
-        einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
+        [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
+        einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
+
+        if [ -n "$STAGES" ] ; then
+           echo -n "Removing stages directory ${STAGES}: "
+           rm -rf "$STAGES" && echo done
+        fi
+
+        # remove directory only if we used the default with process id inside the name
+        if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+           einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
+        fi
      fi
   fi
+
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
+
   exit "$EXIT"
 }
-trap bailout 1 2 3 15
+trap bailout HUP INT QUIT TERM
 
 # we want to execute all the functions only once, simple check for it:
 stage() {
   if [ -n "$2" ] ; then
-     echo "$2" > "$STAGES/$1"
+     echo "$2" > "${STAGES}/${1}"
      return 0
-  elif grep -q done "$STAGES/$1" 2>/dev/null ; then
+  elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
+     eindent
+       ewarn "To reexecute it clean up the according directory inside $STAGES" ; eend 0
+     eoutdent
      return 1
   fi
 }
@@ -209,44 +636,22 @@ stage() {
 # user should recheck his configuration {{{
 # support full automatic installation:
 checkforrun() {
-   dialog --timeout 10 --title "$0" \
+   dialog --timeout 10 --title "$PN" \
           --yesno "Do you want to stop at this stage?
 
-Notice: you are running grml-debootstrap in non-interactive mode.
-grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
+Notice: you are running ${PN} in non-interactive mode.
+${PN} will install Debian ${RELEASE} on ${TARGET}.
 Last chance to quit. Timeout of 10 seconds running....
 
 Do you want to stop now?" 0 0 2>/dev/null
 }
 
-if [ -n "$AUTOINSTALL" ] ; then
-   if checkforrun ; then
-      eerror "Exiting as requested" ; eend 0
-      exit 1
-   fi
-else # if not running automatic installation display configuration and prompt for execution:
-   einfo "$0 - Please recheck configuration before execution:"
-   echo "
-      Target:           $TARGET"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
-      [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
-      [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
-      case "$MNTPOINT" in "$TARGET") ;; *) echo "  Important! Continuing will delete all data from ${TARGET}!" ;; esac
-      echo
-   einfon "Is this ok for you? [y/N] "
-   read a
-   if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
-      eerror "Exiting as requested." ; eend 1
-      exit 1
-   fi
-fi
-# }}}
-
 # create filesystem {{{
 mkfs() {
   if [ -n "$MKFS" ] ; then
      einfo "Running $MKFS on $TARGET"
      $MKFS $TARGET
+     TARGET_UUID="$(vol_id -u $TARGET 2>/dev/null || echo '')"
      eend $?
   fi
 }
@@ -270,24 +675,34 @@ mount_target() {
      if grep -q $TARGET /proc/mounts ; then
         eerror "$TARGET already mounted, exiting."
      else
-       [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
        einfo "Mounting $TARGET to $MNTPOINT"
        mount -o rw,suid,dev $TARGET $MNTPOINT
        eend $?
      fi
   fi
+  if [ -n "$ISODIR" ] ; then
+     einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
+     mkdir -p "$MNTPOINT/$ISODIR"
+     mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
+     eend $?
+  fi
 }
 # }}}
 
 # install main chroot {{{
 debootstrap_system() {
   if ! grep -q $MNTPOINT /proc/mounts ; then
-          mount_target
+     mount_target
+  fi
+  if [ "$_opt_nodebootstrap" ]; then
+     einfo "Skipping debootstrap as requested."
+     return
   fi
-  if grep -q $MNTPOINT /proc/mounts ; then
-     einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using mirror $MIRROR"
-     $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR
+  if grep -q $MNTPOINT /proc/mounts || [ -n "$DIRECTORY" ] ; then
+     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+     [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR || \
+     $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
      eend $?
   else
      eerror "Error: $MNTPOINT not mounted, can not continue."
@@ -299,27 +714,79 @@ debootstrap_system() {
 # prepare chroot via chroot-script {{{
 preparechroot() {
   einfo "Preparing chroot system"
-  cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
+
+  # provide variables to chroot system
+  CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
+  touch $CHROOT_VARIABLES
+  chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
+  echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
+  [ -n "$ARCH" ]         && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
+  [ -n "$GROOT" ]        && echo "GROOT=$GROOT"               >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]         && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]     && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]       && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]          && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]       && echo "CHROOTMIRROR=$MIRROR"       >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]       && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
+  [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]     && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]       && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]  && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+
+  cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
   mkdir $MNTPOINT/etc/debootstrap/
 
   # make sure we have our files for later use via chroot-script
-  cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
-  cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
-  cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
+  cp $VERBOSE $CONFFILES/config    $MNTPOINT/etc/debootstrap/
+  # make sure we adjust the configuration variables accordingly:
+  sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" $MNTPOINT/etc/debootstrap/config
+  sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    $MNTPOINT/etc/debootstrap/config
+  sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          $MNTPOINT/etc/debootstrap/config
+  sed -i "s#GROOT=.*#GROOT=\"$GROOT\"#"       $MNTPOINT/etc/debootstrap/config
+
+  cp $VERBOSE ${_opt_packages:-$CONFFILES/packages} \
+    $MNTPOINT/etc/debootstrap/packages
+  _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
+  [ -f $_opt_debconf -a "$DEBCONF" = 'yes' ] && \
+    cp $VERBOSE $_opt_debconf $MNTPOINT/etc/debootstrap/debconf-selections
+
+  # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
+  cp $VERBOSE $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
+
+  cp $VERBOSE -a -L $CONFFILES/extrapackages/ $MNTPOINT/etc/debootstrap/
 
   # make sure we can access network [relevant for cdebootstrap]
-  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
+  [ -f "$MNTPOINT/etc/resolv.conf" ] || cp $VERBOSE /etc/resolv.conf $MNTPOINT/etc/resolv.conf
+
+  # provide system's /etc/hosts to the target:
+  if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
+     cp $VERBOSE /etc/hosts $MNTPOINT/etc/hosts
+     sed -i "s#127.0.0.1 .*#127.0.0.1       localhost  $HOSTNAME#" /etc/hosts
+  fi
 
   # setup default locales
-  [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
-
-  # copy any existing existing files to chroot
-  [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
-  [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
-  [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
-  [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
-  [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
+  [ -n "$LOCALES" ] && cp $VERBOSE $CONFFILES/locale.gen  $MNTPOINT/etc/locale.gen
+
+  # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
+  ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
+
+  # copy any existing files to chroot
+  [ -d $CONFFILES/bin   ] && cp $VERBOSE -a -L $CONFFILES/bin/*   $MNTPOINT/bin/
+  [ -d $CONFFILES/boot  ] && cp $VERBOSE -a -L $CONFFILES/boot/*  $MNTPOINT/boot/
+  [ -d $CONFFILES/etc   ] && cp $VERBOSE -a -L $CONFFILES/etc/*   $MNTPOINT/etc/
+  [ -d $CONFFILES/sbin  ] && cp $VERBOSE -a -L $CONFFILES/sbin/*  $MNTPOINT/sbin/
+  [ -d $CONFFILES/share ] && cp $VERBOSE -a -L $CONFFILES/share/* $MNTPOINT/share/
+  [ -d $CONFFILES/usr   ] && cp $VERBOSE -a -L $CONFFILES/usr/*   $MNTPOINT/usr/
+  [ -d $CONFFILES/var   ] && cp $VERBOSE -a -L $CONFFILES/var/*   $MNTPOINT/var/
+
+  # copy local network setup to chroot
+  if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
+     [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
+     cp $VERBOSE /etc/network/interfaces $MNTPOINT/etc/network/interfaces
+  fi
+
   eend 0
 }
 # }}}
@@ -344,9 +811,21 @@ chrootscript() {
 grub_install() {
   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
+  elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
+     for device in $SELECTED_PARTITIONS ; do
+        # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
+        # GRUB="$(grubdevice ${TMPDEVICE})"
+        # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
+        # GRUB=$(grubdevice $device)
+        GRUB="$(grubdevice ${device%%[0-9]})"
+        einfo "Installing grub on ${GRUB}:"
+        [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
+        $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
+        eend $?
+     done
   else
      einfo "Installing grub on ${GRUB}:"
-     [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
+     [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
      eend $?
   fi
@@ -355,10 +834,19 @@ grub_install() {
 
 # unmount $MNTPOINRT {{{
 umount_chroot() {
-  if [ -n "$PARTITION" ] ; then
-     einfo "Unmount $MNTPOINT"
-     umount $MNTPOINT
-     eend $?
+  if [ -n "$ISODIR" ] ; then
+     if grep -q "$ISODIR" /proc/mounts ; then
+        einfo "Unmount $MNTPOINT/$ISODIR"
+        umount "$MNTPOINT/$ISODIR"
+        eend $?
+     fi
+  fi
+  if grep -q "$MNTPOINT" /proc/mounts ; then
+     if [ -n "$PARTITION" ] ; then
+        einfo "Unmount $MNTPOINT"
+        umount $MNTPOINT
+        eend $?
+     fi
   fi
 }
 # }}}
@@ -377,17 +865,30 @@ fscktool() {
 # now execute all the functions {{{
 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
          chrootscript grub_install umount_chroot fscktool ; do
-    if stage $i ; then
-       $i && stage $i done || bailout 2 "i"
+    if stage "${i}" ; then
+       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
     fi
 done
 # }}}
 
-# stages {{{
-  echo done > $STAGES/grml-debootstrap
+# finalize {{{
+einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
+
+# Remove temporary mountpoint again
+if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+   einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
+fi
 # }}}
 
-  einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
+# end dialog of autoinstallation {{{
+if [ -n "$AUTOINSTALL" ] ; then
+   dialog --title "$PN" --msgbox \
+          "Finished execution of ${PN}. Enjoy your Debian system." 0 0
+else
+   einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
+fi
+# }}}
 
 ## END OF FILE #################################################################
-# vim: ai tw=100 expandtab foldmethod=marker
+# vim: ai tw=100 expandtab foldmethod=marker shiftwidth=3